      program selectdata

      implicit none

      logical write_cat
      parameter (write_cat=.true.)
      integer NMREG,NGMAX,NLIM_MAX,NRMAX,NPX,NPY,NP_ran,NPX_ran
      parameter (NMREG=3,NGMAX=4*10**6,NRMAX=3*10**6,NLIM_MAX=3
     &,          NPX=2*1800,NPY=2*600
     &,          NP_ran=(4*NPX/3),NPX_ran=int(NP_ran/48))

      real omega0,lambda0,beta
      parameter (omega0=0.3,lambda0=0.7,beta=-11.)
c     beta: has to be set to -11 to get throughout the right k+e correction

      logical recalib,vlim,spec,mu_mask,mag_fix,magerr,zzerr
      integer nb_reg,ng,nr,nr_reg(NMREG),iseed,i,ii,iargc,nlim,lnblnk
     &,       ng_ranmult
      real magmin,magmax,zmin,zmax,compl_cut
      integer id(NGMAX)
      real x(NGMAX),y(NGMAX),z(NGMAX),d(NGMAX),mag(NGMAX),bjlim(NGMAX)
     &     ,mu(NGMAX)
     &,    wsel(NGMAX),w(NGMAX),lim_spec(2*NLIM_MAX),area_reg(NMREG)
     &,    xr(NRMAX),yr(NRMAX),zr(NRMAX),dr(NRMAX),magr(NRMAX),wr(NRMAX)
     &,    sum_wd(NMREG),sum_wdsq(NMREG),sum_wdsq_sel(NMREG)
     &,    sum_wr(NMREG),sum_wrsq(NMREG),sum_wrsq_sel(NMREG)
     &,    magpix(NPX,NPY),mupix(NPX,NPY),comppix(NPX,NPY),zmaxmap(NPX,NPY)

      character*180 maskfile_reg,maskfile(NMREG),selfile_reg
     &,             selfile(NMREG),catname_reg,catname(NMREG)
     &,             catname1_reg,catname1(NMREG),catname2_reg
     &,             catname2(NMREG),maglim_mask_reg,maglim_mask(NMREG)
     &,             mumask_file_reg,mumask_file(NMREG),outfile1
     &,             outfile2,ranfield_centre,ranfield_area
      character region*10,reg*3

      data ranfield_centre/'sub/rancentres.txt'/
      data ranfield_area/'sub/ranfield_area.dat'/
      common /ranfieldfile/ ranfield_centre,ranfield_area
      common /mag_err/ magerr
      common /zz_err/ zzerr


      i=iargc()
      if (i.lt.24) then
         write(0,*) 'number of arguments:', i ,' is wrong'
         write(0,*) 'select.exe recalib vlim mag_fix mu_mask magerr '
     &,     'zzerr spec zmin zmax magmin magmax ' 
         write(0,*) '    compl_cut iseed ng_ranmult region maskfile ' 
     &,     'selfile catname maglimmask ' 
         write(0,*) '    mumaskfile outfile1 outfile2 catname2 '
     &,     'catname3 [nlim lim_spec(1,...,nlim)]'
         stop 'select.exe!'
      endif

      call getlog(1,recalib)
      call getlog(2,vlim)
      call getlog(3,mag_fix)
      call getlog(4,mu_mask)
      call getlog(5,magerr)
      call getlog(6,zzerr)
      call getlog(7,spec)

      call getreal(8,zmin)
      call getreal(9,zmax)
      call getreal(10,magmin)
      call getreal(11,magmax)
      call getreal(12,compl_cut)
      call getint(13,iseed)
      call getint(14,ng_ranmult)

      call getarg(15,region)
      call getarg(16,maskfile_reg)
      call getarg(17,selfile_reg)
      call getarg(18,catname_reg)
      call getarg(19,maglim_mask_reg)
      call getarg(20,mumask_file_reg)
      call getarg(21,outfile1)
      call getarg(22,outfile2)
      call getarg(23,catname1_reg)
      call getarg(24,catname2_reg)

      ii=25
      if ((vlim).or.(spec)) then
         call getint(ii,nlim)
         do i=1,2*nlim
            ii=ii+1
            call getreal(ii,lim_spec(i))
         enddo
      else
         nlim=0
      endif
      write(0,*) 'Read succcessfully the input parameters!'

d      write(0,*) 'maskfile: ',maskfile_reg(1:lnblnk(maskfile_reg))
d      write(0,*) 'selfile: ',selfile_reg(1:lnblnk(selfile_reg))
d      write(0,*) 'catname: ',catname_reg(1:lnblnk(catname_reg))      
d      write(0,*) 'maglimmask: ',maglim_mask_reg(1:lnblnk(maglim_mask_reg))
d      write(0,*) 'mumaskfile: ',mumask_file_reg(1:lnblnk(mumask_file_reg))
d      if (.not.mock) then
d         write(0,*) 'catname1: ',catname1_reg(1:lnblnk(catname1_reg))
d         write(0,*) 'catname2: ',catname2_reg(1:lnblnk(catname2_reg))
d      endif
d      write(0,*) 'outfile1: ',outfile1(1:lnblnk(outfile1))      
d      write(0,*) 'outfile2: ',outfile2(1:lnblnk(outfile2))      


      nb_reg=(index(region,' ')-1)/3
      write(0,*) 'Number of region(s) considered:',nb_reg
      write(0,*) 'Region: ',region

      call set_pivals
      call tabulate_dist(omega0,lambda0,beta)
      call check_pix_ran(NP_ran,NPX_ran)

      do i=1,nb_reg
         area_reg(i)=0.         ! initialisation
         reg=region(1+(i-1)*3:3*i) ! reg contains the region to be sampled
         call filename_reg(maskfile_reg,maskfile(i),reg)
         call filename_reg(selfile_reg,selfile(i),reg)
         call filename_reg(catname_reg,catname(i),reg)

         call filename_reg(maglim_mask_reg,maglim_mask(i),reg)
         call filename_reg(mumask_file_reg,mumask_file(i),reg)
         call filename_reg(catname1_reg,catname1(i),reg)
         call filename_reg(catname2_reg,catname2(i),reg)
      enddo

      call selection(nb_reg,catname,catname1,catname2,maglim_mask
     &,    mumask_file,maskfile,selfile,region,recalib
     &,    NGMAX,ng,x,y,z,d,mag,id,bjlim,wsel,mu,w,vlim,zmax,zmin
     &,    iseed,compl_cut,sum_wd,sum_wdsq,sum_wdsq_sel
     &,    spec,nlim,lim_spec,mag_fix,magmin,magmax,mu_mask
     &,    outfile1,write_cat,area_reg,NPX,NPY,magpix,mupix,comppix)

c     Standard Number of Randoms
      if (ng_ranmult.gt.0) then
         if (NRMAX.lt.ng*ng_ranmult*nb_reg) 
     &        stop 'select.exe: NRMAX too small'
         write(0,*) 'For each region we produce ',ng_ranmult,' times '
     &,             'more randoms!'
         do i=1,nb_reg
            nr_reg(i)=ng*ng_ranmult
         enddo

         call randoms(nb_reg,region,nr,nr_reg,xr,yr,zr,dr,magr,wr
     &,               zmin,zmax,magmin,magmax,nlim,lim_spec,compl_cut
     &,               sum_wr,sum_wrsq,sum_wrsq_sel
     &,               selfile,maskfile,mumask_file,maglim_mask,outfile2
     &,               vlim,mag_fix,mu_mask,iseed,write_cat
     &,               NPX,NPY,mupix,magpix,zmaxmap)

      else
         write(0,*) 'No randoms produced as ng_ranmult is <= 0!'
      endif

c     If required, please specify below the format wanted for the output 
c     files, outfile1 & outfile2.



      end

c----------------------------------------------------------------------------
c
c               SUBROUTINES SPECIFIC FOR SELECTING THE DATA
c
c----------------------------------------------------------------------------
c     This subroutine is a general routine which makes the right galaxy
c     selection, as specified by the input criteria, as vlim, zmax,
c     zmin,...
c     
      subroutine selection(nb_reg,catname1,catname2,catname3,maglim_mask
     &,          mumask_file,maskfile,selfile,region,recalib
     &,          NGMAX,ng,x,y,z,d,mag,id,bjlim,wsel,mu,w,vlim,zmax,zmin
     &,          iseed,compl_cut,sum_wd,sum_wdsq,sum_wdsq_sel
     &,          spec,nlim,lim_spec,mag_fix,magmin,magmax,mu_mask
     &,          outfile,write_cat,area_reg
     &,          NPX,NPY,magpix,mupix,comppix)
 
      implicit none

      logical vlim,spec,mag_fix,mu_mask,write_cat,recalib
      integer NGMAX,ng,iseed,nb_reg,nlim,id(*)
      real x(*),y(*),z(*),d(*),mag(*),wsel(*),w(*),mu(*),zmax
     &,    zmin,compl_cut,sum_wd(*),sum_wdsq(*),sum_wdsq_sel(*),bjlim(*)
     &,    lim_spec(*),magmax,magmin,area_reg(*)
      integer NPX,NPY,NP,np_x,np_y,iimag,iicomp,iisel
      real  magpix(NPX,NPY),mupix(NPX,NPY),comppix(NPX,NPY)
      real alpha,galpha,mag1,mag2,f_mu,cf_mu,zz_error,mag_error
     &,    mag_sys_error
      character*180 maskfile(*),selfile(*),maglim_mask(*),mumask_file(*)
     &,             catname1(*),catname2(*),catname3(*)
      character region*(*),outfile*(*)

      integer ireg,sgn,noff,ng_reg,icol,ii,ix,iy,iseed1
      real px,py,pz,zlim,zplus1,rx,ry,magval,muval,mag_plate_error
     &,    area_tot,ran3,compl,sum,sumt,sum_w,sum_wsq,sum_wsq_sel
      character reg*3

      sum_w=0.
      sum_wsq=0.
      sum_wsq_sel=0.

      do ireg=1,nb_reg
         reg=region(1+(ireg-1)*3:3*ireg)! reg contains the region to be sampled

         if (ireg.eq.1) then    ! set the right offset 
            noff=1              ! Initialize offset to 1
            ng=0                ! Initialize the total number of galaxies 
            call area_region(nb_reg,area_reg,area_tot,maskfile
     &,                      compl_cut,region,NPX,NPY,comppix)
         else
            noff=ng+1
         endif

c        Read parent catalogue in cartesian coordinates
         call readcart(catname1(ireg),ng_reg,id(noff)
     &,       x(noff),y(noff),z(noff),mag(noff),bjlim(noff))
         

c        Read best redshift
         icol=1                 ! zzbest
         call readascii_col(catname2(ireg),icol,ng_reg,d(noff))
            
c        Read appropriate weight
         icol=2
         if (spec) icol=7
         call readascii_col(catname3(ireg),icol,ng_reg,wsel(noff))
            
c        Set wsel to -8 if not in the right spectral class!            
         if (spec) then
            call sel_spec(catname1(ireg),ng_reg,wsel(noff),nlim,lim_spec) 
         endif

c        Record mu values for each galaxy so that these can be passed
c        to modify()
         if (reg.ne.'ran') then ! Ran fields have mu-mask in another format 
            write(0,*) '   read mu mask from'
            write(0,*) mumask_file(ireg)
            call read_mask(mupix,np_x,np_y,mumask_file(ireg),NPX,NPY,NP)
         endif                  
            
         do ii=noff,noff-1+ng_reg
            if (reg.ne.'ran') then
               call eq_2dfrx(NP,x(ii),y(ii),z(ii),rx,ry,sgn)
               call rx_ix_map(NP,sgn,rx,ry,ix,iy)
               mu(ii)=mupix(ix,iy)
            else
               call ranmask_val2(maglim_mask(ireg),mumask_file(ireg)
     &,                          x(ii),y(ii),z(ii),magval,mu(ii))
            end if
         enddo   
         write(0,*) 'Number of gal. in sample of region ',reg,' :',ng_reg

         if (noff+ng_reg.gt.NGMAX) stop 'ng too large for NGMAX'

c        Set the vectors in the appropriate format: redshift space!
         call sampleformat(ng_reg,x(noff),y(noff),z(noff)
     &,                    d(noff),wsel(noff),zlim)
         write(0,*) 'Galaxy redshift extends to ',zlim,vlim,nlim

c        Select a volume limited sample. In the same time make sure that
c        the apparent magnitude cut are ok (even for non-volume limited 
c        samples!)
         call volume_limited(vlim,zmin,zmax,nlim,lim_spec
     &,                      mag_fix,magmin,magmax,ng_reg,d(noff)
     &,                      mag(noff),wsel(noff),x(noff),y(noff)
     &,                      z(noff),reg,maglim_mask(ireg),NPX,NPY
     &,                      magpix)

c        Convert to Mpc/h, set galaxy weights & make the final sample 
c        selection
         call modify(ng_reg,x(noff),y(noff),z(noff),d(noff),mag(noff)
     &,       id(noff),bjlim(noff),w(noff),wsel(noff),mu(noff),reg
     &,       maskfile(ireg),selfile(ireg),sum_wd(ireg),zmax,zmin,vlim
     &,       nlim,compl_cut,iseed,sum_wdsq(ireg),sum_wdsq_sel(ireg)
     &,       mag_fix,magmin,magmax,outfile,write_cat,area_reg,region)

         write(0,*) 'Number of gal. selected from region ',reg,' :',ng_reg
     &,             ' data sum of weights =',sum_wd(ireg)

         ng=ng+ng_reg
         sum_w=sum_w+sum_wd(ireg)
         sum_wsq=sum_wsq+sum_wdsq(ireg)
         sum_wsq_sel=sum_wsq_sel+sum_wdsq_sel(ireg)
      enddo
      if (write_cat) close(19) ! It has been opened in subroutine modify

      write(0,*) 'Total number of galaxies in sample: ',ng
      write(0,*) 'Total sum of weights =',sum_w
      write(0,*) '                     =',(sum_wd(ireg),ireg=1,nb_reg)
      write(0,*) 'Total sum of w^2     =',sum_wsq
      write(0,*) '                     =',(sum_wdsq(ireg),ireg=1,nb_reg)
      write(0,*) 'Total sum of w^2 n   =',sum_wsq_sel
      write(0,*) '                     =',(sum_wdsq_sel(ireg),ireg=1,nb_reg)

      if (ng.eq.0) then
         write(0,*) 'With these selection conditions, no galaxies have '
     &,             'been selected!'
         stop 'selectdata stops due to lack of galaxies!'
      endif
         
      return
      end

c-----------------------------------------------------------------------------
c Convert redshift to Mpc/h 
c Define the galaxy weights
c Also possibly reduce the sample by imposing a redshift limit etc
c      
      subroutine modify(ng,x,y,z,d,mag,id,bjlim,w,wsel,mu,reg,maskfile
     &,          selfile,sum_w,zmax,zmin,vlim,nlim
     &,          compl_cut,iseed,sum_wsq,sum_wsq_sel,mag_fix
     &,          magmin,magmax,outfile,write_cat,area_reg,region)
************************************variables*********************************
      implicit none
      logical vlim,mag_fix,write_cat
      integer ng,iseed,nlim,id(*)
      real x(*),y(*),z(*),d(*),w(*),mag(*),wsel(*),bjlim(*),mu(*),sum_w,zmax
     &,    zmin,compl_cut,sum_wsq,sum_wsq_sel,magmin,magmax
     &,    area_reg(*)
      character maskfile*(*),selfile*(*),reg*3,outfile*(*),region*(*)

      logical opencat,vlim_sel
      integer ifirst,ii,imag,icompl,izz,i,iabsmag,iseed1,iplate,ino_z,icomp
      real PI,zpl1,zzz,rc,dlum,dlzcomb,z_hub,selz,compl,zmaxpl1
     &,    zminpl1,zran,ran3,perturb,ra,dec
      real*8 dsum_w,dsum_wsq,dsum_wsq_sel
      real  alpha0,bstar0,psi0,maglim_sel_file,selz_mu
      data ifirst/1/
      save ifirst,iseed1,zran,zmaxpl1,zminpl1,PI,opencat
******************************************************************************
      write(0,*) 'Select in ',reg,' region : ng (initial)=',ng
      vlim_sel=vlim

      write(0,*) 'selfile=',selfile
      open(10,file=selfile,status='old',form='formatted')
      read(10,100) alpha0,bstar0,psi0,maglim_sel_file
 100  format(10X,f9.5,8X,f10.5,10X,f10.8,9X,f10.5)
      close(10)
      write(0,*) 'Parameters from the selection function:'
      write(0,*) 'alpha=',alpha0,' bstar=',bstar0,' phistar='
     &     ,                   psi0,' maglim=',maglim_sel_file
      write(0,*) 'magmin=',magmin
      write(0,*) 'These are being used in modify() to compute the'
      write(0,*) 'outputted selz and selz_mu BUT note this maglim is not used'

c
      if (ifirst.eq.1) then
         opencat=write_cat 
         ifirst=0
         PI=4.*atan(1.)
         iseed1=iseed
         zran=0.00001           ! limit of the precision of 2dFGRS redshifts
         zmaxpl1=zmax+1.
         zminpl1=zmin+1.
      endif
      ii=0
      imag=0
      icompl=0
      icomp=0
      izz=0
      iplate=0
      dsum_w=0.0d+00
      dsum_wsq=0.0d+00
      dsum_wsq_sel=0.0d+00

      if (vlim_sel) selz=0. !initialize to a given value

      if (opencat) then
         opencat=.false.    ! Open the file only ones
         write(0,*) 'Write galaxy catalogue to file: ',outfile
         open(19,file=outfile,status='unknown',form='formatted')
         write(19,'(a,3(1x,a,1x,f9.4,a,1x,f9.4))') 
     &        '# area: ',(region(1+3*(i-1):3*i),area_reg(i),i=1,3)
         write(19,'(a,a)') '#    ra      dec       zz       mag     '
     &,       ' wsel       compl      selz       selz_mu   bjlim     serial'
      endif

      do i=1,ng

         if (wsel(i).gt.0.) then

            call in_2df_mask_xyz(maskfile,x(i),y(i),z(i),compl)

            if (compl.gt.compl_cut) then

               zzz=sqrt( x(i)**2+y(i)**2+z(i)**2 )
               perturb=1.0+zran*(ran3(iseed1)-0.5)/zzz
               x(i)=x(i)*perturb
               y(i)=y(i)*perturb
               z(i)=z(i)*perturb
               zzz=sqrt( x(i)**2+y(i)**2+z(i)**2 )               
               
               zpl1=1.0+zzz
                  
               if ((vlim) .or. ((.not.vlim).and.(zpl1.le.zmaxpl1)
     &                                     .and.(zpl1.ge.zminpl1))) then

                  ii=ii+1
                  mag(ii)=mag(i)
                  id(ii)=id(i)
                  bjlim(ii)=bjlim(i)
                  w(ii)=wsel(i)
                  mu(ii)=mu(i)

                  call search_dist(rc,zpl1,dlum,dlzcomb,2)

                  x(ii)=x(i)*rc/zzz
                  y(ii)=y(i)*rc/zzz
                  z(ii)=z(i)*rc/zzz
                  d(ii)=d(i)*rc/zzz
                  z_hub=zpl1-1.0

                  call selfunc(selz,selz_mu,
     &                 z_hub,alpha0,bstar0,psi0,magmin,bjlim(ii),mu(ii))

                  dsum_w=dsum_w+dble(w(ii))
                  dsum_wsq=dsum_wsq+dble(w(ii))**2
                  dsum_wsq_sel=dsum_wsq_sel+dble(selz)*dble(w(ii))**2
                  
                  if (write_cat) then
                     call xyz_radec(x(ii),y(ii),z(ii),ra,dec)
                     write(19,110) ra,dec,z_hub,mag(ii),w(ii),compl,selz
     &,                            selz_mu,bjlim(ii),id(ii)
 110                 format(3(f9.6,1x),f7.3,1x,2(f9.6,1x),2(f12.9,1x)
     &,                     f7.4,1x,I10)

                  endif

               else
                  izz=izz+1
               endif
            else if (compl.eq.-10.) then
               iplate=iplate+1
            else
               icompl=icompl+1
            endif
         else
            if (abs(wsel(i)+1.0).le.1.0e-03) then !ie wsel=-1
               imag=imag+1
            else if (wsel(i).ge.-2) then
               icomp=icomp+1
            else if (wsel(i).ge.-3) then
               izz=izz+1
            else if (wsel(i).ge.-4) then
               iabsmag=iabsmag+1
            else if (wsel(i).ge.-6) then
               ino_z=ino_z+1
            endif
         endif
      enddo
      
      sum_w=dsum_w
      sum_wsq=dsum_wsq
      sum_wsq_sel=dsum_wsq_sel

      ng=ii
      
      write(0,*) 'number in redshift sample: ',ng,' weights:'
     &,           sum_w,sum_wsq,sum_wsq_sel
      write(0,*) 'after rejecting using mask, magnitude & redshift '
     &,          'limits and completeness cut'

      write(0,*) '  number rejected by magnitude=',imag
      write(0,*) '  number rejected by completeness (sector+mu)=',icomp

      if (izz.ne.0) 
     &     write(0,*) '  number rejected by redshift cut-off=',izz

      write(0,*) '  number rejected by plate selection=',iplate

      if (vlim) 
     &     write(0,*) '  number rejected by M magnitude=',iabsmag

      write(0,*) '  number rejected by rejection of low completeness '
     &,          'sectors=',icompl

      return
      end

c----------------------------------------------------------------------------
c
c                  SUBROUTINES RELATIVE TO ANGULAR COVERAGE
c
c----------------------------------------------------------------------------
c     This subroutine calculates the area of the different regions
      subroutine area_region(nb_reg,area_reg,area_tot,maskfile,compl_cut
     &,                      region,NPX,NPY,mask)

      implicit none
      
      integer nb_reg,NPX,NPY
      real area_reg(*),area_tot,compl_cut,mask(NPX,NPY)
      character*180 maskfile(*)
      character region*(*)

      integer nmax
      real thetamin,PI
      parameter(nmax=100,thetamin=1.014,PI=3.1415926536)
c     The parameters are specific for the 2dFGRS
      integer NP,np_xx,np_yy,ix,iy,nb_field,i,j,ifirst
      real area(3),area_save,fact,xc(nmax),yc(nmax)
     &,    zc(nmax),comp(nmax),area_ran(nmax)
      character reg*3
      character*180 name_mask_last
      data ifirst/1/
      save area,area_save,ifirst

      character ranfield_centre*180,ranfield_area*180
      common /ranfieldfile/ ranfield_centre,ranfield_area


      if (ifirst.eq.1) then
         ifirst=0
         fact=(45./atan(1.))**2 ! Conversion factor: solid angle -> sq. deg.
         if (nb_reg.gt.3) 
     &     stop 'area_region: more region used than allowed!'

c        Determine the effective areas of each of the regions considered
         area_save=0.

         do i=1,nb_reg
            area(i)=0. !initialisation
            reg=region(1+(i-1)*3:3*i)
            if (reg.ne.'ran') then
               call read_mask(mask,np_xx,np_yy,maskfile(i),NPX,NPY,NP)
               do iy=1,np_yy
                  do ix=1,np_xx
                     if (mask(ix,iy).gt.compl_cut) area(i)=area(i)+mask(ix,iy)
                  enddo
               enddo
               area(i)=area(i)*fact*4./real(np**2) !effective area in sq. deg.
               name_mask_last=maskfile(i)
            else
               call ran2df_cen_used(nb_field,xc,yc,zc,comp,maskfile(i))
               call ran2df_cen_used(nb_field,xc,yc,zc,area_ran
     &,                             ranfield_area)
c              area_ran is the maximal area of each random field in sq. deg.
               do j=1,nb_field
                  if (comp(j).gt.compl_cut) 
     &                 area(i)=area(i)+comp(j)*area_ran(j)
               enddo
            endif
            area_save=area_save+area(i)
         enddo
         write(0,*) 'area ',region,' :',area_save
      endif

      do i=1,nb_reg
         area_reg(i)=area(i)
      enddo
      area_tot=area_save

      return
      end

c-----------------------------------------------------------------------------
c
c              SUBROUTINES SPECIFIC FOR READING THE DATA FILES
c
c-----------------------------------------------------------------------------
c     Given a file name and a region, replace in file2 all the regions by the
c     one stored in reg.
      subroutine filename_reg(file1,file2,reg)

      implicit none

      character file1*(*),file2*(*),reg*(*)

      integer ii,num,jj,ifirst,lnblnk
      character empty*180,file3*180
      data ifirst/1/
      save empty,ifirst
      

      if (ifirst.eq.1) then
         ifirst=0.
         empty='                                                    '
     &       //'                                                    '
     &       //'                                                    '
     &       //'                                                    '
      endif

      file2=file1
      num=len(reg)-1
      jj=1
      if ((index(file2,'sgp').ne.0)) then
         ii=index(file2,'sgp')
         do while (jj.ne.0)
            file2(ii:ii+num)=reg
            ii=ii+num+1
            file3=file2(ii:)//empty
            jj=index(file3,'sgp')
            ii=ii+jj-1
         enddo
      else if ((index(file2,'ngp').ne.0)) then
         ii=index(file2,'ngp')
         do while (jj.ne.0)
            file2(ii:ii+num)=reg
            ii=ii+num+1
            file3=file2(ii:)//empty
            jj=index(file3,'ngp')
            ii=ii+jj-1
         enddo
      else if ((index(file2,'ran').ne.0)) then
         ii=index(file2,'ran')
         do while (jj.ne.0)
            file2(ii:ii+num)=reg
            ii=ii+num+1
            file3=file2(ii:)//empty
            jj=index(file3,'ran')
            ii=ii+jj-1
         enddo
      else if ((index(file2,'reg').ne.0)) then
         ii=index(file2,'reg')
         do while (jj.ne.0)
            file2(ii:ii+num)=reg
            ii=ii+num+1
            file3=file2(ii:)//empty
            jj=index(file3,'reg')
            ii=ii+jj-1
         enddo
      end if

      write(0,*) 'file: ',file2(1:lnblnk(file2))

      return
      end

c---------------------------------------------------------------------------
c     Read the input catalogue
      subroutine readcart(catname,ng,id,x,y,z,mag,bjlim)

      implicit none

      integer ng,id(*)
      real*4 x(*),y(*),z(*),mag(*),bjlim(*)
      character catname*(*)

      integer i,ncol,lnblnk
      real zz,zzraw
      real*8 ra(1),dec(1)


      open(11,file=catname,status='old',form='formatted')
c     id ra dec bj zz zraw bjlim qual bjg bjp bjgp plate 
c     field date eta ccd ecce orie jon area
c     Read Header
      read(11,'(7x,i3,6x,i7)') ncol,ng
      read(11,*) !skip column headings
      do i=1,ng
         read(11,*) id(i),ra(1),dec(1),mag(i),zz,zzraw,bjlim(i)
         call radecdble_xyz(1,ra(1),dec(1),x(i),y(i),z(i))
      enddo
      close(11)
      write(0,*) 'read ',ng,' objects from ',catname(1:lnblnk(catname))
      return
      end

c---------------------------------------------------------------------------
c     Select the right spectral class
      subroutine sel_spec(catname,ng,wsel,nlim,lim_spec) 

      implicit none

      integer ng,nlim
      real wsel(*),lim_spec(*)
      character catname*(*)

      integer i,lnblnk
      real eta,lim1,lim2

c     Define lim1 & lim2
      lim1=lim_spec(2*nlim-1)
      lim2=lim_spec(2*nlim)
      write(0,*) 'Spectral class limits:',lim1,lim2

c     Read eta parameter

      open(11,file=catname,form='formatted',status='old')
      read(11,*) !skip column headings
      read(11,*) !skip column headings
      do i=1,ng
         read(11,'(119x,f8.3)') eta
         if ((wsel(i).gt.0.).and.((eta.le.lim1).or.(eta.gt.lim2))) then
            wsel(i)=-8.
         endif
      enddo
      close(11)

      write(0,*) 'read ',ng,' eta parameters from ',catname(1:lnblnk(catname))
      return
      end

c---------------------------------------------------------------------------
      subroutine sampleformat(ng,x,y,z,d,wsel,zlim)

      implicit none

      integer ng
      real zlim,x(*),y(*),z(*),d(*),wsel(*)

      integer i
            
      zlim=0.
      do i=1,ng
         if ((wsel(i).gt.0.).and.(d(i).gt.0.)) then
            x(i)=x(i)*d(i)
            y(i)=y(i)*d(i)            
            z(i)=z(i)*d(i)
            zlim=max(zlim,d(i))
         else
            wsel(i)=0.
         endif
      enddo

      return
      end

c----------------------------------------------------------------------------
c
c             SUBROUTINES FOR MAGNITUDE LIMIT AND VOLUME LIMIT
c
c----------------------------------------------------------------------------
      subroutine mag_limit(vlim,mag_fix,magmin,magmax,ng,mag,x,y,z
     &,                    wsel,reg,maglim,maglimmask,NPX,NPY,magpix)

      implicit none

      logical mag_fix,vlim
      integer ng,NPX,NPY
      real maglim,magmin,magmax,mag(*),x(*),y(*),z(*),wsel(*),magpix(NPX,NPY)
      character reg*(*),maglimmask*(*)

      integer np_x,np_y,np,sgn,ix,iy,ifirst,igal,i,jfld
      real rx,ry,magval
      character reg_save*3
      data ifirst/1/
      save ifirst,NP,reg_save
      

      if ((ifirst.eq.1).or.(reg.ne.reg_save)) then !Read magnitude limit mask
         ifirst=0
         reg_save=reg
         if (reg.ne.'ran') then
            call read_mask(magpix,np_x,np_y,maglimmask,NPX,NPY,NP)
         endif
      endif

      if (mag_fix) then
         
         igal=0
         if (reg.ne.'ran') then
            do i=1,ng
               call eq_2dfrx(NP,x(i),y(i),z(i),rx,ry,sgn)
               call rx_ix_map(NP,sgn,rx,ry,ix,iy)       
               if (ix.ge.1 .and. ix.le.NPX .and. iy.ge.1 .and. iy.le.NPY) then
                  if ( (mag(i).gt.magmax).or.(mag(i).lt.magmin).or.
     &                 (magpix(ix,iy).lt.magmax)) then
                     wsel(i)=-1.
                     igal=igal+1
                  endif 
               else
                  wsel(i)=-1.
                  igal=igal+1
               endif
            enddo
         else
            do i=1,ng
               call ranmask_val(maglimmask,x(i),y(i),z(i),magval)
               if ( (mag(i).gt.magmax).or.(mag(i).lt.magmin).or.
     &              (magval.lt.magmax)) then
                  wsel(i)=-1.
                  igal=igal+1
               endif 
            enddo
         endif
         write(0,*) 'Number of galaxies outside magnitude range: ',igal
     &,             ' ( ',reg,' )'
         
      else if ((vlim).and.(.not.mag_fix)) then

         if (reg.ne.'ran') then
            call eq_2dfrx(NP,x(1),y(1),z(1),rx,ry,sgn)
            call rx_ix_map(NP,sgn,rx,ry,ix,iy)
            if (ix.ge.1 .and. ix.le.NPX .and. iy.ge.1 .and. iy.le.NPY) then
               maglim=magpix(ix,iy)
            else
               maglim=-2.
            endif
         else
            call ranmask_val(maglimmask,x(1),y(1),z(1),maglim)
         endif

      else 
         igal=0
         if (reg.ne.'ran') then
            do i=1,ng
               call eq_2dfrx(NP,x(i),y(i),z(i),rx,ry,sgn)
               call rx_ix_map(NP,sgn,rx,ry,ix,iy)
               if (ix.ge.1 .and. ix.le.NPX .and. iy.ge.1 .and. iy.le.NPY) then

                  if ((mag(i).gt.magpix(ix,iy)).and.(magpix(ix,iy).gt.0)) then
                     wsel(i)=-1.
                     igal=igal+1
                  else if (mag(i).gt.magpix(ix,iy)) then
                     wsel(i)=-1. 
                  endif
               else
                  wsel(i)=-1.
                  igal=igal+1
               endif
            enddo
         else
            jfld=0
            do i=1,ng
               call ranmask_val(maglimmask,x(i),y(i),z(i),magval)
               if (mag(i).gt.magval) then
                  wsel(i)=-1.
                  igal=igal+1
               endif
            enddo
         endif
         
         write(0,*) 'Number of galaxies fainter than mag limit: ',igal
     &,             ' ( ',reg,' )' 
         igal=0
         do i=1,ng
            if (mag(i).lt.magmin) then
               wsel(i)=-1.
               igal=igal+1
            endif
            if (wsel(i).gt.0.) jfld=jfld+1
         enddo
         write(0,*) 'Number of galaxies brighter than mag limit: ',igal
     &,             ' ( ',reg,' )',jfld
         write(0,*) ' magmin=',magmin
      endif

      return
      end

c----------------------------------------------------------------------------
      subroutine volume_limited(vlim,zmin,zmax,nlim,lim_abs
     &,                         mag_fix,magmin,magmax,ng,zz,mag,wsel
     &,                         x,y,z,reg,maglimmask,NPX,NPY,magpix)

      implicit none

      logical vlim,mag_fix
      integer ng,nlim,NPX,NPY
      real zz(*),mag(*),wsel(*),zmin,zmax,lim_abs(*)
     &,    magmax,magmin,x(*),y(*),z(*),magpix(NPX,NPY)
      character reg*(*),maglimmask*(*)

      real magmax_old,magmin_old
      parameter (magmax_old=19.45,magmin_old=14.0)
      integer i,igal,igal_1,igal_2,igal_3,igal_4
      real zmax_est,zmax1,zmin1,zplus1,absmag_max1,absmag_min1,absmag
     &,    r,d,dlzc,maglim,magmax1,magmin1,kpluse
      external kpluse
      

      if ((.not.vlim).and.(nlim.lt.1)) then
         call mag_limit(vlim,mag_fix,magmin,magmax,ng,mag,x,y,z
     &,                 wsel,reg,maglim,maglimmask,NPX,NPY,magpix)
         return
      endif

      if (mag_fix) then 
         magmax1=magmax
         magmin1=magmin
      else
         magmax1=magmax!!!!!!!!!!!!magmax_old
         magmin1=magmin
      endif

      if (vlim) then
c        Definition of zmin & zmax such that the sample is volume limited
         zmin1=zmin             ! a not too bad guess
         absmag_min1=lim_abs(1)
         call get_zextreme(absmag_min1,magmin1,zmin1,kpluse)

         zmax1=zmax             ! reasonable guess
         absmag_max1=lim_abs(2)
         call get_zextreme(absmag_max1,magmax1,zmax1,kpluse)
      
         if (zmin1.lt.zmin) then
            zmin1=zmin
            zplus1=1.+zmin1
            call search_dist(r,zplus1,d,dlzc,2)
            absmag_min1=magmin1-25.-5.*log10(d)-kpluse(zmin1)
            write(0,*) 'Absolute magnitude cut too bright: ',lim_abs(1),' '
     &,                'has been changed to ',absmag_min1
            lim_abs(1)=absmag_min1
         endif
         
         if (zmax1.gt.zmax) then
            zmax1=zmax
            zplus1=1.+zmax1
            call search_dist(r,zplus1,d,dlzc,2)
            absmag_max1=magmax1-25.-5.*log10(d)-kpluse(zmax1)
            write(0,*) 'Absolute magnitude cut too faint: ',lim_abs(2),' '
     &,                'has been changed to ',absmag_max1    
            lim_abs(2)=absmag_max1
         endif      

         if (mag_fix) then
            write(0,*) 'For a volume limited catalogue with fixed apparent'
     &,                ' magnitude cuts ',magmin1,' -> ',magmax1,' :'   
            write(0,*) 'M_min = ',absmag_min1,' M_max = ',absmag_max1
            write(0,*) 'zmin = ',zmin1,' zmax = ',zmax1       
         else
            write(0,*) 'For a volume limited catalogue with indicative '
     &,                'magnitude cuts ',magmin1,' -> ',magmax1,' :'   
            write(0,*) 'M_min = ',absmag_min1,' M_max = ',absmag_max1
            write(0,*) 'zmin = ',zmin1,' zmax = ',zmax1            
         endif
      else
         zmin1=zmin
         zmax1=zmax
         zmax_est=zmax
      endif

      if (nlim.ge.2) then
         absmag_min1=lim_abs(3)
         absmag_max1=lim_abs(4)
      else
         absmag_min1=lim_abs(1)
         absmag_max1=lim_abs(2)
      endif
      write(0,*) 'Selection for :',absmag_min1,' < M < ',absmag_max1

      igal=0
      igal_1=0
      igal_2=0
      igal_3=0
      igal_4=0

      if (mag_fix) 
     &   call mag_limit(vlim,mag_fix,magmin,magmax,ng,mag,x,y,z,wsel,reg
     &,                 maglim,maglimmask,NPX,NPY,magpix)

      do i=1,ng
         if (wsel(i).gt.0.) then
            igal=igal+1
            zplus1=1.+zz(i)
            call search_dist(r,zplus1,d,dlzc,2)
            absmag=mag(i)-25.-5.*log10(d)-kpluse(zz(i))
            
            if ((absmag.ge.absmag_min1).and.(absmag.le.absmag_max1))then

               if (mag_fix) then
                  if (zz(i).gt.zmax1) then
                     wsel(i)=-2.
                     igal_2=igal_2+1
                  else if (zz(i).lt.zmin1) then
                     wsel(i)=-3.
                     igal_3=igal_3+1
                  endif
               else 
c                 Find zmax1 for that particular region corresponding
c                 to maglim.
                  
                  call mag_limit(vlim,mag_fix,magmin,magmax,1,mag(i)
     &,                x(i),y(i),z(i),wsel(i),reg,maglim,maglimmask
     &,                NPX,NPY,magpix)
                     

                  if ((mag(i).le.maglim).and.(mag(i).ge.magmin)) then
                     
                     if (vlim) then
                        zmax_est=zmax1 ! good guess....
                        call get_zextreme(lim_abs(2),maglim,zmax_est
     &,                                   kpluse)
                        zmax_est=min(zmax,zmax_est)
                     endif
                     
                     if (zz(i).gt.zmax_est) then
                        wsel(i)=-2.
                        igal_2=igal_2+1
                     else if (zz(i).lt.zmin1) then
                        wsel(i)=-3.
                        igal_3=igal_3+1
                     endif
                  else
                     wsel(i)=-1.
                     igal_1=igal_1+1
                  endif
               endif
            else
               wsel(i)=-4.
               igal_4=igal_4+1
            endif
         else if (wsel(i).eq.-1.) then
            igal_1=igal_1+1
         endif
      enddo


      write(0,*) 'Number of galaxies with weights:',igal
      write(0,*) 'Number of galaxies outside M range:',igal_4
      write(0,*) 'Number of galaxies outside z range:',igal_2+igal_3
      write(0,*) 'Number of galaxies above zmax:',igal_2
      write(0,*) 'Number of galaxies below zmin:',igal_3
      write(0,*) 'Number of galaxies outside m range:',igal_1
      write(0,*) 'Number of galaxies in this volume:'
     &,           igal-igal_2-igal_3-igal_4
      
      return
      end

c----------------------------------------------------------------------------
      subroutine get_zextreme(absmax,maglim,z_est,kecor)

      implicit none

      real absmax,maglim,z_est,kecor
      
      real EPS
      parameter (EPS=1.e-5)
      real r,dlzc,diff,fac,zplus1,d_est

c     Search for z_est (assuming z_est contains an initial guess for the 
c     final value).

      fac=maglim-absmax-25.
      diff=1.
      do while (diff.gt.EPS)
         d_est = 10**(0.2*(fac-kecor(z_est)))
         call search_dist(r,zplus1,d_est,dlzc,3)
         diff = abs((zplus1-1.)-z_est)
         if (diff.gt.EPS) z_est=zplus1-1.
      enddo
      z_est=(z_est+(zplus1-1.))/2.

      return
      end

c-----------------------------------------------------------------------------
c
c               SUBROUTINES SPECIFIC FOR RANDOMS CATALOGUES
c
c-----------------------------------------------------------------------------
c   Set up the random catalogue with the same radial and angular
c   selection function as the data
c
      subroutine randoms(nb_reg,region,nr,nr_reg,xr,yr,zr,dr,magr,wr
     &,          zmin,zmax,magmin,magmax,nlim,lim_abs,compl_cut
     &,          sum_wr,sum_wsq,sum_wsq_sel
     &,          selfile,maskfile,mumask_file,maglim_mask,outfile
     &,          vlim,mag_fix,mu_mask,iseed_save,write_cat
     &,          NPX,NPY,mupix,magpix,zmaxmap)

************************************variables*********************************
      implicit none
      logical vlim,mag_fix,mu_mask,write_cat
      integer nr,iseed_save,nr_reg(*),nb_reg,nlim,NPX,NPY
      real xr(*),yr(*),zr(*),dr(*),magr(*),wr(*)
     &,    compl_cut,sum_wr(*),sum_wsq(*),sum_wsq_sel(*)
     &,    lim_abs(*),magmin,magmax,zmin,zmax,mupix(NPX,NPY)
     &,    magpix(NPX,NPY),zmaxmap(NPX,NPY)
      character*180 selfile(*),maskfile(*),mumask_file(*),maglim_mask(*)
      character region*(*),outfile*(*)

      real PI,EPS
      parameter (PI=3.14159265359,EPS=3.e-6)
      logical init,vlim_sel,opencat

      integer iseed,ix,iy,NP,np_xx,np_yy,ifirst,sgn,ireg,ii,i
      real xx,yy,zz,rr,compl,ran,zzz,rc,dlum,dlzcomb,zminplus1,zmaxplus1
     &,    zplus1,z_hub,selz,zplus1h,zlim,zmax_ran,selz_mu
d      real etime,t0,t1,cpt,tarray(2)
      real alpha0,bstar0,psi0,ra,dec,ranmag_z,rx,ry,maglim,mag,absmag
     &,    zmax_vlim,mag_plate_error
     &,    zmin_vlim,mu,f_mu,kpluse,maglim_sel,ran3,mag_error,zmax_pix
     &,    mag_sys_error,magerrmax,magsyserrmax,maglim_sel_file,muval
      real*8 dsum_wr,dsum_wsq,dsum_wsq_sel
      character reg_save*3,reg*3
      integer ntries,itry
      real area,nsqdg,psi0_randoms
      external mag_error,mag_sys_error,mag_plate_error,ranmag_z,kpluse
     &,        ran3
      save ifirst,zmax_vlim,zmin_vlim,reg_save
     &,    maglim,selz,zmaxplus1,zminplus1
      data ifirst/1/
      data reg_save/'   '/
      common /selection_ranmag/ alpha0,bstar0,psi0
      common /area_tries/ area,ntries
******************************************************************************
      zlim=0.                   ! initialize redshift limit
      iseed=iseed_save          ! save random initial seed
      ii=0                      ! initialize the offset
      opencat=write_cat
      if (opencat) write(0,*) 'Write random catalogue to file: ',outfile

      do ireg=1,nb_reg
         init=.true.
         vlim_sel=vlim
         reg=region(1+(ireg-1)*3:3*ireg)

         write(0,*) 'Create in ',reg,' region : nr (randoms)=',nr_reg(ireg)
         
         nr=nr_reg(ireg)+ii
d         t0=etime(tarray)
         dsum_wr=0.0d+00
         dsum_wsq=0.0d+00
         dsum_wsq_sel=0.0d+00

         if ((ifirst.eq.1).or.(reg.ne.reg_save)) then
            ifirst=0
            reg_save=reg
            if (vlim) then
               zmin_vlim=zmin
               call get_zextreme(lim_abs(1),magmin,zmin_vlim,kpluse)
               write(0,*) 'For random catalogue: zmin_vlim =',zmin_vlim

               if (reg.ne.'ran') then
                  call read_mask(magpix,np_xx,np_yy,maglim_mask(ireg)
     &,                          NPX,NPY,NP)
                  call zmax_map(NPX,NPY,np_xx,np_yy,magpix,lim_abs(2)
     &,                         zmaxmap,mag_fix,magmax,zmax_ran)
               else if (mag_fix) then
                  zmax_vlim=zmax
                  call get_zextreme(lim_abs(2),magmax,zmax_vlim,kpluse)
                  write(0,*) 'For random fields: zmax_vlim:',zmax_vlim,zmax
                  zmaxplus1=zmax_vlim+1.
                  zmax_ran=zmax_vlim
               else
                  call getranmask_max(maglim_mask(ireg),rr)
                  zmax_ran=zmax
                  call get_zextreme(lim_abs(2),rr,zmax_ran,kpluse)
                  zmax_ran=min(zmax,zmax_ran)
                  write(0,*) 'For random fields: zmax_ran:',zmax_ran,zmax
               endif
               zminplus1=zmin_vlim+1.
               if (zmin_vlim.lt.zmin) then
                  if (abs(zmin_vlim-zmin).gt.EPS) then
                     write(0,*) 'Problem here...',zmin,zmin_vlim
                     stop 'randoms'
                  else
                     zmin_vlim=zmin
                  endif
               endif
               mag=magmin ! this to ensure that mag has a value (not important
                          ! in this case as the magnitude do not come into 
                          ! account in a volume limited sample)
               maglim=magmax
               selz=0.
               call duplicate_common_selfun
            else
               zminplus1=zmin+1.
               zmaxplus1=zmax+1.
               zmax_ran=zmax
               if (reg.ne.'ran') then 
                  call read_mask(magpix,np_xx,np_yy,maglim_mask(ireg)
     &,                          NPX,NPY,NP)
                  if (.not.mag_fix) then
c                    Find magnitude limit of faintest pixel               
                     maglim_sel=0.0
                     do iy=1,NPY
                        do ix=1,NPX
                           maglim_sel=max(maglim_sel,magpix(ix,iy))
                        end do
                     end do
                     write(0,*) 'faintest magnitude limit=',maglim_sel
                  endif
               else if (.not.mag_fix) then
                  call getranmask_max(maglim_mask(ireg),maglim_sel)
               endif

               if (mag_fix) then
                  maglim_sel=magmax
               endif

               open(10,file=selfile(ireg),status='old',form='formatted')
               read(10,100) alpha0,bstar0,psi0,maglim_sel_file
 100           format(10X,f9.5,8X,f10.5,10X,f10.8,9X,f10.5)
               close(10)
               alpha0=-alpha0 ! ranmag_z is set up with this funny definition!

               write(0,*) 'Parameters from the selection function:'
               write(0,*) 'alpha=',-alpha0,' bstar=',bstar0,' phistar='
     &,                   psi0,' maglim=',maglim_sel_file

c              Estimate approximate maximum magnitude measurement error
c              that will be applied to the randoms.
               magerrmax=0.0
               magsyserrmax=0.0
               do i=1,100
                  magerrmax=max(magerrmax,
     &                 mag_error(iseed)+mag_plate_error(0,0.0,0.0,0.0,iseed))
                  zplus1=1.0+real(i)*0.3/real(100)
                  magsyserrmax=max(magsyserrmax,mag_sys_error(zplus1))
               end do
               magerrmax=(magerrmax+magsyserrmax)*1.02 
                                !1.02: fudge factor to be on the safer side
               write(0,*) 'Max magnitude error:',magerrmax,magerrmax/1.02

c              Faintest possible magnitude limit
               maglim_sel=maglim_sel+magerrmax
               write(0,*) 'Adopted Magnitude limit for generating '
     &,                   'random cat.: ',maglim_sel

c              Tabulate and store in common block /selfun_ran/
               write(0,*) 'Selection function to this magnitude limit '
               write(0,*) 'but other parameters as above will be used'
               write(0,*) 'and stored in common block /selfun_ran/'

               call tabulate_sel_ran(psi0,bstar0,-alpha0,maglim_sel,magmin)
               call get_nsqdg(nsqdg)

            endif

            if ((mu_mask).and.(reg.ne.'ran')) then
               call read_mask(mupix,np_xx,np_yy,mumask_file(ireg)
     &,                       NPX,NPY,NP)
            else
               mu=25.0  !dummy value
            endif
         endif

         if (opencat) then
            opencat=.false.
            write(0,*) 'Write random catalogue to file: ',outfile
            open(19,file=outfile,status='unknown',form='formatted')
            write(19,'(a,a)') '#    ra      dec       zz      mag     '
     &,             'wsel       compl      selz      selz_mu     bjlim'
         endif
         
         itry=0
         do while (ii.lt.nr) 
            call ran_cat(xx,yy,zz,rr,iseed,zmax_ran,vlim,init,reg)
            itry=itry+ntries !count number tries made in ran_cat()
            if (reg.ne.'ran') then
               call in_2df_mask_xyz(maskfile(ireg),xx,yy,zz,compl)
            else
               call ranmask_val3(maglim_mask(ireg),mumask_file(ireg)
     &,             maskfile(ireg),xx,yy,zz,maglim,muval,compl)
            endif

            if (compl.gt.compl_cut) then
               ran=ran3(iseed)
               
               if (ran.lt.compl) then
                  zzz=sqrt( xx**2+yy**2+zz**2 )
                  
                  zplus1h=1.0+rr !get real hubble flow distance
                  zplus1=1.0+zzz !get redshift space distance

                  if ((vlim).and.(reg.ne.'ran')) then
                     call eq_2dfrx(NP,xx,yy,zz,rx,ry,sgn)
                     call rx_ix_map(NP,sgn,rx,ry,ix,iy)
                     zmaxplus1=zmaxmap(ix,iy)+1.
                  else if ((.not.vlim).and.(reg.ne.'ran')) then
                     call eq_2dfrx(NP,xx,yy,zz,rx,ry,sgn)
                     call rx_ix_map(NP,sgn,rx,ry,ix,iy)
                     mag=ranmag_z(zplus1h,maglim_sel,iseed)
                     maglim=magpix(ix,iy)
                     mag=mag-mag_error(iseed) ! apply measurement error
                     mag=mag-mag_plate_error(0,xx,yy,zz,iseed) 
                     mag=mag-mag_sys_error(zplus1h)
                     if (mu_mask) muval=mupix(ix,iy)
                  else if (reg.eq.'ran') then
                     if (vlim) then
                        if (mag_fix) then
                           zmax_pix=0.
                           if (maglim.ge.magmax) zmax_pix=zmax_vlim
                        else if (maglim.gt.0.) then
                           call get_zextreme(lim_abs(2),maglim,zmax_pix
     &,                                      kpluse)
                        endif
                        zmaxplus1=zmax_pix+1.
                     else
                        mag=ranmag_z(zplus1h,maglim_sel,iseed)
                        mag=mag-mag_error(iseed) ! apply measurement error
                        mag=mag-mag_plate_error(0,xx,yy,zz,iseed) 
                        mag=mag-mag_sys_error(zplus1h)
                     endif
                  endif

                  if ((.not.vlim) .and. mag.le.maglim .and. mu_mask)then
c                    Need to regenerate redshift and magnitude if
c                    rejected by the mu_mask
                     mu=muval
                     f_mu= 1.0-exp(mag-mu)
c                    In the case that we don't enter the following do while
c                    this next assignment will make z_hub/zzz=1 and so result
c                    in no change to xx,yy,zz,rr and zzz.
                     z_hub=zzz 
                     do while (mag.gt.maglim .or. f_mu.lt.ran3(iseed) )
c                       Generate a new Hubble flow redshift z_hub
                        call get_redshift_ran(z_hub,iseed)
                        zplus1h=1.0+z_hub
                        mag=ranmag_z(zplus1h,maglim_sel,iseed)
                        mag=mag-mag_error(iseed) ! apply measurement error
                        mag=mag-mag_plate_error(0,xx,yy,zz,iseed) 
                        mag=mag-mag_sys_error(zplus1h)
                        f_mu= 1.0-exp(mag-mu)
                     end do
c                    Either make zplus1 equal to 1 + the Hubble flow
c                    redshift or generate a redshift space value by
c                    perturbing zhub by the previous ratio of redshift
c                    space to real space distance, zzz/rr.
                     z_hub=z_hub*(zzz/rr) ! add redshift space 
                     zplus1=1.0+z_hub     ! distortion to hubble flow
c                    NB z_hub now includes the peculiar velocity

                     xx=xx*z_hub/zzz !rescale by ratio of redshift distance
                     yy=yy*z_hub/zzz 
                     zz=zz*z_hub/zzz  
                     rr=rr*z_hub/zzz
                     zzz=z_hub
                  end if

c                 Selection of randoms with the right absolute magnitude!
                  if ((.not.vlim).and.(nlim.ge.1)) then
                     call search_dist(rc,zplus1,dlum,dlzcomb,2)
                     absmag=mag-25.-5.*log10(dlum)-kpluse(zplus1-1.)
                     if ((absmag.lt.lim_abs(1)).or.(absmag.gt.lim_abs(2)))
     &                 zplus1=zmaxplus1+1. ! crazy value to take gal away...
                  endif

                  if ((zplus1.le.zmaxplus1).and.(zplus1.ge.zminplus1).and.
     &               ( ((mag_fix).and.(magmax.le.maglim).and.(mag.le.magmax))
     &                 .or. ((.not.mag_fix).and.(mag.le.maglim)) ).and.
     &               (mag.ge.magmin)) then
                     ii=ii+1
                     zlim=max(zlim,zplus1-1.)
                     call search_dist(rc,zplus1,dlum,dlzcomb,2)
                     xr(ii)=xx*rc/zzz
                     yr(ii)=yy*rc/zzz
                     zr(ii)=zz*rc/zzz
                     dr(ii)=rr*rc/zzz

                     magr(ii)=mag
                     z_hub=zplus1-1.0
                     wr(ii)=1.0/compl
                     call selfunc(selz,selz_mu,
     &                    z_hub,-alpha0,bstar0,psi0,magmin,maglim,mu)

                     dsum_wr=dsum_wr+dble(wr(ii))
                     dsum_wsq=dsum_wsq+dble(wr(ii))**2
                     dsum_wsq_sel=dsum_wsq_sel+dble(selz)*dble(wr(ii))**2
                     
                     if (write_cat) then
                        call xyz_radec(xr(ii),yr(ii),zr(ii),ra,dec)
                        write(19,110) ra,dec,z_hub,mag,wr(ii),compl,selz
     &,                               selz_mu,maglim
 110                    format(3(f9.6,1x),f7.3,1x,2(f9.6,1x),2(f12.9,1x)
     &,                        f7.4)
                     endif
                  endif
               endif
            endif
         enddo
         sum_wr(ireg)=dsum_wr
         sum_wsq(ireg)=dsum_wsq
         sum_wsq_sel(ireg)=dsum_wsq_sel

d         t1=etime(tarray)
d         cpt = t1 - t0 
d         write(0,*)'Generate randoms for ',reg,' took ',cpt,' sec'
         write(0,*)'itry=',itry
         write(0,*)'area=',area
         write(0,*)'nsqdg=',nsqdg
         psi0_randoms=psi0*real(itry)/(nsqdg*area*(180.0/PI)**2)      
         write(19,'(a,f15.6)') '# phi_star= ',psi0_randoms
         if (ireg.eq.nb_reg) close(19)
      enddo

      write(0,*) 'number of galaxies in random sampled catalogue nr=',nr
     &,          ' with z<',zlim
d      write(0,*) 'Random sum of weights =',sum_wr

      return
      end

c---------------------------------------------------------------------------
      subroutine zmax_map(NPX,NPY,np_x,np_y,maglim,absmax,zmax,mag_fix
     &,          magmax,zmax_ran)

      implicit none
      
      logical mag_fix
      integer NPX,NPY,np_x,np_y
      real maglim(NPX,NPY),zmax(NPX,NPY),absmax,magmax,zmax_ran
      
      integer ix,iy
      real kpluse,zmax_fix
      external kpluse



      if (mag_fix) then
         call get_zextreme(absmax,magmax,zmax_fix,kpluse)
         zmax_ran=zmax_fix
      else
         zmax_ran=0.
      endif

c     For each pixel, estimate zmax
      do iy=1,np_y
         do ix=1,np_x
            zmax(ix,iy)=0.
            if (mag_fix) then
               if (maglim(ix,iy).ge.magmax) zmax(ix,iy)=zmax_fix
            else if (maglim(ix,iy).gt.0.) then
               call get_zextreme(absmax,maglim(ix,iy),zmax(ix,iy),kpluse)
               zmax_ran=max(zmax_ran,zmax(ix,iy))
           endif
         enddo
      enddo

      return
      end

c---------------------------------------------------------------------------
c
c                SUBROUTINES FOR K+E CORRECTIONS
c
c---------------------------------------------------------------------------
      function kecor_2df(z)

      implicit none
      
      real kecor_2df,z
      integer  class
      common /spec_class/ class

      if (class.eq.-1) then ! this is the default value when not using 
                            ! spectral class information
         
         kecor_2df=(z+6.0*z**2)/(1.0+20.0*z**3) !Bruzual & Charlot + SDSS mean
         !kecor_2df=0.03*z/(0.01+z**4) ! Used in xi(L) & xi(eta,L) papers 
         !kecor_2df=2.5*log10(1.+z)
         !kecor_2df=3*z/(1+z)
      else if (class.eq.0) then
         kecor_2df=1.9 * z + 2.7 * z**2 !2.4 * z + 2.7 * z**2
      else if (class.eq.1) then
         kecor_2df=2.6 * z + 4.3 * z**2 !3.0 * z + 4.6 * z**2
      else if (class.eq.2) then
         kecor_2df=1.9 * z + 2.2 * z**2 !2.3 * z + 2.1 * z**2
      else if (class.eq.3) then
         kecor_2df=1.3 * z + 2.0 * z**2 !1.8 * z + 1.8 * z**2
      else if (class.eq.4) then
         kecor_2df=0.9 * z + 2.3 * z**2 !1.4 * z + 1.8 * z**2
      else if (class.eq.5) then   ! average class 3 & 4
         kecor_2df=1.2 * z + 2.1 * z**2  ! guess....
      else if (class.eq.6) then ! average class 2, 3 & 4
         kecor_2df=1.5 * z + 2.1 * z**2  ! guess....
      endif

      return
      end

c---------------------------------------------------------------------------
      function kpluse(z)

      implicit none
      
      real kecor_2df,z,kpluse
      external kecor_2df

      kpluse = (z+6.0*z**2)/(1.0+8.9*z**2.5) ! Bruzual & Charlot + SDSS mean + tweak  
c      kpluse=0.03*z/(0.01+z**4) ! Used in xi(L) & xi(eta,L) papers
c      kpluse=kecor_2df(z)

      return
      end
