c  Subroutine to read the 2dF mask
c                           
      subroutine  read_mask(mask,np_xx,np_yy,name_mask,np_x,np_y,np)
*************************************variables********************************
      implicit none
      character name_mask*(*)
      integer np_x,np_y,np_xx,np_yy,np,ix,iy
      real mask(np_x,np_y)
******************************************************************************
      open(14,file=name_mask,status='old',form='unformatted')
      read(14) np_xx,np_yy
      call NP_set(np_xx,np_yy,np,0)
      if ((np_xx.le.np_x).and.(np_yy.le.np_y)) then
         do ix=1,np_xx
            read(14) (mask(ix,iy),iy=1,np_yy)
         enddo
      else
         write(0,*) 'Dimension of the mask too big!'
         write(0,*) ' Mask: NPX= ',np_xx,' NPY= ',np_yy
         stop 'in_2df_mask'
      endif
      close(14)
      return
      end
c----------------------------------------------------------------------------
c  Subroutine to read the 2dF mask
c                           
      subroutine read_mask_ran(mask,nb_ff,np_xx,np_yy,name_mask
     &,                        nb_f,np_x,np_y,np)
*************************************variables********************************
      implicit none
      character name_mask*(*)
      integer i,np_x,np_y,nb_f,np_xx,np_yy,nb_ff,np,ix,iy
      real mask(nb_f,np_x,np_y)
******************************************************************************
      open(14,file=name_mask,status='old',form='unformatted')
      read(14) nb_ff,np_xx,np_yy
      call NP_set(np_xx,np_yy,np,0)
      if ((np_xx.le.np_x).and.(np_yy.le.np_y).and.(nb_ff.le.nb_f)) then
         do i=1,nb_ff
            do ix=1,np_xx
               read(14) (mask(i,ix,iy),iy=1,np_yy)
            enddo
         enddo
      else
         write(0,*) 'Dimension of the mask too big!'
         write(0,*) ' Mask: NPX= ',np_xx,' NPY= ',np_yy,' Nb_f=',Nb_ff
         stop 'in_2df_mask'
      endif
      close(14)
      return
      end
c-----------------------------------------------------------------------------
c     For a given position in ra & dec, this subroutine tells if this
c     position is inside the 2df_mask or not, by returning the actual
c     completeness.

      subroutine in_2df_mask_radec(name_mask,ra,dec,compl)

      implicit none

      real ra,dec,compl
      character name_mask*(*),name_mask_last*180

      integer np_x,np_y
      parameter (np_x=2*1800,np_y=2*600)
      real rpix(np_x,np_y),x,y,z,rx,ry
      integer np_xx,np_yy,ifirst,ix,iy,np,sgn,sgn_mask
      save ifirst,np_xx,np_yy,np,sgn_mask
      data ifirst/1/
      common/same_mask/ rpix,name_mask_last

c     On the first call, the program reads the mask
      if (ifirst.eq.1 .or. name_mask_last.ne.name_mask) then
         name_mask_last=name_mask
         if (index(name_mask,'ran').ne.0) then
            ifirst=-1
         else
c            write(*,*) 'reading mask:',name_mask
            call read_mask(rpix,np_xx,np_yy,name_mask,np_x,np_y,np)
            if (index(name_mask,'sgp').ne.0) then
               sgn_mask=1
            else
               sgn_mask=-1
            endif
            ifirst=0
         endif
      endif

      call radec_xyz(ra,dec,x,y,z)
      if (ifirst.eq.-1)  then
         call in_2df_ran_xyz(name_mask,x,y,z,compl)
         return
      endif

      compl=0.0  !default value
      call eq_2dfrx(np,x,y,z,rx,ry,sgn)
      if (sgn.ne.sgn_mask) return
      call rx_ix_map(np,sgn,rx,ry,ix,iy)

      if (ix.ge.1 .and. ix.le.np_xx .and. iy.ge.1 .and. iy.le.np_yy) 
     &     compl=rpix(ix,iy)
                
      return
      end

c---------------------------------------------------------------------------
c  Version of routine above but using cartesian equatorial coordinates
c  and returning actual completeness

      subroutine in_2df_mask_xyz(name_mask,x,y,z,compl)

      implicit none

      real x,y,z,compl
      character name_mask*(*),name_mask_last*180

      integer np_x,np_y
      parameter (np_x=2*1800,np_y=2*600)
      real rpix(np_x,np_y),rx,ry
      integer np_xx,np_yy,ifirst,ix,iy,np,sgn,sgn_mask
      save ifirst,np_xx,np_yy,np,sgn_mask
      data ifirst/1/
      common/same_mask/ rpix,name_mask_last

c     On the first call, the program reads the mask
      if (ifirst.eq.1 .or. name_mask_last.ne.name_mask) then
         name_mask_last=name_mask
         if (index(name_mask,'ran').ne.0) then
            ifirst=-1
         else
            call read_mask(rpix,np_xx,np_yy,name_mask,np_x,np_y,np)
            if (index(name_mask,'sgp').ne.0) then
               sgn_mask=1
            else
               sgn_mask=-1
            endif
            ifirst=0
         endif
      endif

      if (ifirst.eq.-1)  then 
         call in_2df_ran_xyz(name_mask,x,y,z,compl)
         return
      endif

      compl=0.0  !default value
      call eq_2dfrx(np,x,y,z,rx,ry,sgn)
      if (sgn.ne.sgn_mask) return
      call rx_ix_map(np,sgn,rx,ry,ix,iy)
      
      if (ix.ge.1 .and. ix.le.np_xx .and. iy.ge.1 .and. iy.le.np_yy)
     &    compl=rpix(ix,iy)

      return
      end

c---------------------------------------------------------------------------
c  Copy of routine above using cartesian equatorial coordinates
c  and returning actual completeness; with this routine, 2 mask 
c  files can be opened in the same time.

      subroutine in_2df_mask_xyz2(name_mask,x,y,z,compl)

      implicit none

      real x,y,z,compl
      character name_mask*(*),name_mask_last*180

      integer np_x,np_y
      parameter (np_x=2*1800,np_y=2*600)
      real rpix(np_x,np_y),rx,ry
      integer np_xx,np_yy,ifirst,ix,iy,np,sgn,sgn_mask
      save ifirst,np_xx,np_yy,np,sgn_mask
      data ifirst/1/
!      common/same_mask2/ rpix,name_mask_last

c     On the first call, the program reads the mask
      if (ifirst.eq.1 .or. name_mask_last.ne.name_mask) then
         name_mask_last=name_mask
         if (index(name_mask,'ran').ne.0) then
            ifirst=-1
         else
            call read_mask(rpix,np_xx,np_yy,name_mask,np_x,np_y,np)
            if (index(name_mask,'sgp').ne.0) then
               sgn_mask=1
            else
               sgn_mask=-1
            endif
            ifirst=0
         endif
      endif

      if (ifirst.eq.-1)  then 
         call in_2df_ran_xyz2(name_mask,x,y,z,compl)
         return
      endif

      compl=0.0  !default value
      call eq_2dfrx(np,x,y,z,rx,ry,sgn)
      if (sgn.ne.sgn_mask) return
      call rx_ix_map(np,sgn,rx,ry,ix,iy)
      
      if (ix.ge.1 .and. ix.le.np_xx .and. iy.ge.1 .and. iy.le.np_yy)
     &    compl=rpix(ix,iy)

      return
      end

c-----------------------------------------------------------------------------
c For a given position in cartesian x, y & z, this subroutine tells if this
c position is inside the used random fields or not, by returning the actual
c completeness of the field.
      subroutine in_2df_ran_xyz(file_field,x,y,z,compl)

      implicit none

      real x,y,z,compl
      character file_field*(*)

      integer nmax
      real theta_min
      parameter (nmax=100,theta_min=1.014)
      logical in
      integer i,ifirst,nb_field,io
      real costheta,costheta_r,costheta_min,xc(nmax),yc(nmax),zc(nmax)
     &,    comp(nmax),r,ra,dec
      character file_field_last*180
      data ifirst/1/
      save ifirst,nb_field,xc,yc,zc,comp,file_field_last,costheta_min

c     On the first call, reads the file containing the random fields
      if (ifirst.eq.1 .or. file_field_last.ne.file_field) then
         ifirst=0
         call ran2df_cen_used(nb_field,xc,yc,zc,comp,file_field)
         costheta_min=cos(theta_min*atan(1.)/45.)
         file_field_last=file_field
      endif

      i=0
      in=.false.
      r=sqrt(x**2+y**2+z**2)
      costheta_r=costheta_min*r
      do while ((.not.in).and.(i.lt.nb_field))
         i=i+1
         costheta=(x*xc(i)+y*yc(i)+z*zc(i))
         if (costheta.gt.costheta_r) then   ! We use here the fact the random
            in=.true.                       ! fields doesn't overlapp with 
         endif                              ! each other...
      enddo
      
      if (in) then
         call xyz_radec(x,y,z,ra,dec)
         call test_hole(ra,dec,io)    ! hole (io=0) or not (io=1)
         compl=comp(i)*real(io)       ! io = 0 if in a hole; 1 otherwise
      else
         compl=0.
      endif

      return
      end

c-----------------------------------------------------------------------------
c For a given position in cartesian x, y & z, this subroutine tells if this
c position is inside the used random fields or not, by returning the actual
c completeness of the field.
      subroutine in_2df_ran_xyz2(file_field,x,y,z,compl)

      implicit none

      real x,y,z,compl
      character file_field*(*)

      integer nmax
      real theta_min
      parameter (nmax=100,theta_min=1.014)
      logical in
      integer i,ifirst,nb_field,io
      real costheta,costheta_r,costheta_min,xc(nmax),yc(nmax),zc(nmax)
     &,    comp(nmax),r,ra,dec
      character file_field_last*180
      data ifirst/1/
      save ifirst,nb_field,xc,yc,zc,comp,file_field_last,costheta_min

c     On the first call, reads the file containing the random fields
      if (ifirst.eq.1 .or. file_field_last.ne.file_field) then
         ifirst=0
         call ran2df_cen_used(nb_field,xc,yc,zc,comp,file_field)
         costheta_min=cos(theta_min*atan(1.)/45.)
         file_field_last=file_field
      endif

      i=0
      in=.false.
      r=sqrt(x**2+y**2+z**2)
      costheta_r=costheta_min*r
      do while ((.not.in).and.(i.lt.nb_field))
         i=i+1
         costheta=(x*xc(i)+y*yc(i)+z*zc(i))
         if (costheta.gt.costheta_r) then   ! We use here the fact the random
            in=.true.                       ! fields doesn't overlapp with 
         endif                              ! each other...
      enddo
      
      if (in) then
         call xyz_radec(x,y,z,ra,dec)
         call test_hole(ra,dec,io)    ! hole (io=0) or not (io=1)
         compl=comp(i)*real(io)       ! io = 0 if in a hole; 1 otherwise
      else
         compl=0.
      endif

      return
      end

c-----------------------------------------------------------------------------
c     This subroutine reads the used 2dF random field centres from the file 
c     name, which contains also the overall completeness of the field (with 
c     respect to the underlying density field). Read the information written
c     by write_ran2df_cen.
      subroutine ran2df_cen_used(nb_field,xc,yc,zc,comp,name)

      implicit none

      integer nb_field
      real xc(*),yc(*),zc(*),comp(*)
      character name*(*)

      integer i

      open(unit=13,file=name,status='old',form='unformatted')
      read(13) nb_field
      read(13) (xc(i),i=1,nb_field)
      read(13) (yc(i),i=1,nb_field)
      read(13) (zc(i),i=1,nb_field)
      read(13) (comp(i),i=1,nb_field)
      close(13)

      return
      end

c-----------------------------------------------------------------------------
c Convert an equatorial cartesian coordinate to the rx,ry pixel
c coordinate used for the 2df mask. This subroutine is valid for both 
c sgp and ngp elements.
c
c This has been checked to verify that it is the inverse of the mapping 
c given in inv_eq_2dfrx
c
      subroutine  eq_2dfrx(NP,x,y,z,rx,ry,sgn)
*************************************variables********************************
      implicit none
      real x,y,z,r,PI,EPS
      parameter (EPS=3.e-13)
      integer ifirst,sgn,NP,ix_min,iy_min
      real racen,sc,deccen,rx,ry
      double precision costheta
      real xc,yc,zc,phi,dec_gc,ra_gc,xgc,ygc,zgc,sintheta_2
     & ,xgp,ygp,zgp,xx,yy,zz,phi0
      save ifirst,sc,xc,yc,zc,xgc,ygc,zgc,xgp,ygp,zgp,phi0,PI !ix_min,iy_min
      data ifirst/1/
******************************************************************************

c On the first call define the values which define the
c centre, orientation and scale of the transformation
      if (ifirst.eq.1) then
         ifirst=0
         PI= atan(1.)*4.
c        This is the direction of the Galactic Centre as adopted
c        by Steve Maddox
         racen  = 12.3*PI/180.0  
         deccen = -27.5*PI/180.0  
         sc = 120.0*PI/180.0
         xc=cos(deccen)*cos(racen)
         yc=cos(deccen)*sin(racen)
         zc=sin(deccen)
c        This is a direction perpendicular to above but otherwise
c        arbitrary provided that the phi0 has then been correctly
c        set to be the offset between this arbitrary direction and
c        that used for the projection of the APM SGP region 
         ra_gc   = -94.40593*PI/180.0 
         dec_gc  = -28.90771*PI/180.0 
         phi0=236.97694*PI/180.0
         xgc=cos(dec_gc)*cos(ra_gc)
         ygc=cos(dec_gc)*sin(ra_gc)
         zgc=sin(dec_gc)
c        Generate the mutually perpendicular unit vector via
c        the cross product
         xgp = yc*zgc-zc*ygc
         ygp = zc*xgc-xc*zgc
         zgp = xc*ygc-yc*xgc
      end if
c     
c  Section utilized on each call
c     Find components in the new 3D Cartesian system      
      r=sqrt(x**2+y**2+z**2)
      zz=(x*xc+y*yc+z*zc)
      xx=(x*xgc+y*ygc+z*zgc)
      yy=(x*xgp+y*ygp+z*zgp)
c     Compute corresponding spherical polar angles
      costheta= abs(dble(zz)/dble(r))
      sgn=int(sign(1.,zz/r)) ! tells if x,y,z is in the ngp or sgp region
      phi=phi0-atan2(yy,xx)
      if (phi.gt.2.0*PI) phi=phi-2.0*PI
c     Apply the Zenithal Equal Area Projection
      if (sngl(dble(1.0)-costheta).ge.EPS) then
         sintheta_2=sngl(dsqrt(dble(0.5)*(dble(1.0)-costheta)))
      else
         sintheta_2=0.
      endif
      r=2.*sintheta_2 !If sc changes, change this like:r=sintheta_2/sin(sc/4.)
c     convert to x,y coordinate
      xx=-r*sin(phi)*real(NP)*0.5
      yy= r*cos(phi)*real(NP)*0.5
      
      call bound_map_2df(NP,sgn,ix_min,iy_min)

      rx=xx+0.5*real(NP)-1.*real(ix_min) 
      ry=-yy+0.5*real(NP)-1.*real(iy_min)

      return
      end

c-----------------------------------------------------------------------------
c Convert the pixel postion rx,ry to ra and dec.
c This subroutine is the inverse of eq_2dfrx. Works for both ngp and sgp,
c as long as the sgn is given (respectively by -1 and 1).
      subroutine inv_eq_2dfrx(NP,rx,ry,sgn,x,y,z)
************************************variables*********************************
      implicit none
      integer NP
      real rx,ry,x,y,z

      real*8 EPS
      parameter (EPS=3.e-13)
      integer ifirst,sgn,iy_min,ix_min
      real*8 r,PI,EPS2,a(3,3),PI_hf,PI_3hf
      real*8 racen,sc,deccen,costheta,delta_phi
     & ,xc,yc,zc,phi,dec_gc,ra_gc,xgc,ygc,zgc,sintheta_2
     & ,xgp,ygp,zgp,xx,yy,zz,phi0,rnp,rnp_inv
      save ifirst,sc,phi0,PI,EPS2,a,PI_hf,PI_3hf,xc,yc,zc   !ix_min,iy_min
      data ifirst/1/
******************************************************************************

c On the first call define the values which define the
c centre, orientation and scale of the transformation
      if (ifirst.eq.1) then
         ifirst=0
         EPS2=sqrt(0.5*EPS)
         PI= atan(1.)*4.
         PI_hf=PI/2.
         PI_3hf=3.*PI/2.
c        This is the direction of the Galactic Centre as adopted
c        by Steve Maddox
         racen  = 12.3*PI/180.0  
         deccen = -27.5*PI/180.0  
         sc = 120.0*PI/180.0
         xc=cos(deccen)*cos(racen)
         yc=cos(deccen)*sin(racen)
         zc=sin(deccen)
c        This is a direction perpendicular to above but otherwise
c        arbitrary provided that the phi0 has then been correctly
c        set to be the offset between this arbitrary direction and
c        that used for the projection of the APM SGP region 
         ra_gc   = -94.40593*PI/180.0 
         dec_gc  = -28.90771*PI/180.0 
         phi0=236.97694*PI/180.0
         xgc=cos(dec_gc)*cos(ra_gc)
         ygc=cos(dec_gc)*sin(ra_gc)
         zgc=sin(dec_gc)
c        Generate the mutually perpendicular unit vector via
c        the cross product
         xgp = yc*zgc-zc*ygc
         ygp = zc*xgc-xc*zgc
         zgp = xc*ygc-yc*xgc
c        Define Matrix a which is the inverse (transpose) of the base matrix
         a(1,1)=xc
         a(1,2)=xgc
         a(1,3)=xgp
         a(2,1)=yc
         a(2,2)=ygc
         a(2,3)=ygp
         a(3,1)=zc
         a(3,2)=zgc
         a(3,3)=zgp
      end if
c     
c  Section utilized on each call
      call bound_map_2df(NP,sgn,ix_min,iy_min)

      rnp=0.5*dble(NP)
      rnp_inv=1./rnp

      xx=rx+dble(ix_min)-rnp    !0.5*dble(NP)
      yy=-ry-dble(iy_min)+rnp   !0.5*dble(NP)
      if ((xx.eq.0.).and.(yy.eq.0.)) then
         x=real(xc*dble(sgn))
         y=real(yc*dble(sgn))
         z=real(zc*dble(sgn))
         return
      endif
      phi=atan2(-xx,yy)+2.*PI
      if (xx.eq.0.) then
         r=rnp_inv*yy/cos(phi)  !/(dble(NP)*0.5)
      else if (yy.eq.0.) then
         r=-rnp_inv*xx/sin(phi) !/(dble(NP)*0.5)
      else if (    ((sgn.eq. 1).and.(abs(xx).gt.50.))
     &         .or.((sgn.eq.-1).and.(abs(yy).lt.50.))) then
         r=-rnp_inv*xx/sin(phi) !/(dble(NP)*0.5)
      else
         r=rnp_inv*yy/cos(phi)  !/(dble(NP)*0.5)
      endif

      sintheta_2=r*0.5          !If sc changes, change like this:
                                !   sintheta_2=r*sin(sc/4.)
      if (sintheta_2.gt.EPS2) then
         costheta=(dble(1.)-dble(2.*sintheta_2**2))*dble(sgn)
      else
         costheta=dble(sgn)
      endif

      zz=costheta
      if (zz.gt.1.) zz=1.
      if (zz.lt.-1.) zz=-1.
      delta_phi=phi0-phi
      if (delta_phi.lt.0.) delta_phi=delta_phi+2.*PI
      if ((delta_phi.le.PI_hf).or.(delta_phi.ge.PI_3hf)) then ! xx is positive
         xx=sqrt((1.-zz**2)/(1.+tan(delta_phi)**2))
         yy=xx*tan(delta_phi)
      else                                                    ! xx is negative
         xx=-sqrt((1.-zz**2)/(1.+tan(delta_phi)**2))
         yy=xx*tan(delta_phi)
      endif
      x=real(a(1,1)*zz+a(1,2)*xx+a(1,3)*yy)
      y=real(a(2,1)*zz+a(2,2)*xx+a(2,3)*yy)
      z=real(a(3,1)*zz+a(3,2)*xx+a(3,3)*yy)
      
      return
      end

c-----------------------------------------------------------------------------
c This subroutine contains the boundaries of the sgp and ngp pixel map. It
c returns the ix_min and iy_min which are the offsets of the two maps.
      subroutine bound_map_2df(NP,sgn,ix_min,iy_min)

      implicit none

      integer NP,sgn,ix_min,iy_min
      
      if (sgn.eq.1) then        ! use the sgp map
c     Dependig on the value of NP, we must redefine the offset in the x and y
c     directions. For the 2df_sgp region, we have these limits:
c         ix_min=NP*15/100; ix_max=NP*90/100
c         iy_min=NP*44/100; iy_max=NP*69/100
         ix_min=NP*15/100
         iy_min=NP*44/100
      else if (sgn.eq.-1) then  ! use the ngp map
c     Dependig on the value of NP, we must redefine the offset in the x and y
c     directions. For the 2df_ngp region, we have these limits:
c         ix_min=NP*7/100; ix_max=NP*82/100
c         iy_min=NP*60/100; iy_max=NP*85/100
         ix_min=NP*7/100
         iy_min=NP*60/100
      endif

      return
      end

c----------------------------------------------------------------------------
c This subroutine gives the right boundaries for each random field mask, ie.
c calculates the offset needed such that the pixel center of each random 
c field, given by (rxc,ryc), is located at( NPX_ran/2, NPY_ran/2) .
c
      subroutine bound_map_ran(NPX_ran,NPY_ran,NP_ran,sgn,rxc,ryc
     &,          ixc_min,iyc_min)

      implicit none

      integer NPX_ran,NPY_ran,NP_ran,sgn,ixc_min,iyc_min
      real rxc,ryc

      integer ixc,iyc
c      call bound_map_2df(NP,sgn,ix_min,iy_min)
c      rxc=rxc+real(ix_min)      ! real position of the random field 
c      ryc=ryc+real(iy_min)      ! on the pixel map
      
      call rx_ix_map(NP_ran,sgn,rxc,ryc,ixc,iyc)
      ixc_min=ixc-int(NPX_ran/2)
      iyc_min=iyc-int(NPY_ran/2)


      return
      end

c-----------------------------------------------------------------------------
c This subroutine converts real pixel coordinates rx,ry to integer ix,iy pixel
c coordinates. NP and sgn might be intresting for a further extension of 
c this subroutine.
      subroutine rx_ix_map(NP,sgn,rx,ry,ix,iy)

      implicit none
      
      integer NP,sgn,ix,iy
      real rx,ry

      ix=int(rx+0.5)
      iy=int(ry+0.5)
         
      return
      end

c-----------------------------------------------------------------------------
c This subroutine converts integer pixel coordinates ix,iy to real rx,ry pixel
c coordinates which corresponds to the center of the pixel. NP and sgn might 
c be intresting for a further extension of this subroutine.
      subroutine ix_rx_map(NP,sgn,ix,iy,rx,ry)

      implicit none
      
      integer NP,sgn,ix,iy
      real rx,ry

      rx=real(ix)
      ry=real(iy)
         
      return
      end
      
c-----------------------------------------------------------------------------
c This subroutine transforms x,y & z cartesian coordinates to ra & dec.
      subroutine xyz_radec(x,y,z,ra,dec)

      implicit none

      real x,y,z,ra,dec
      real zz,PI2
      parameter (PI2=6.2831853072)

      zz=sqrt(x**2+y**2+z**2)
      dec= asin(z/zz)
      if (y.lt.0) then
         ra= atan2(y,x)+PI2
      else
         ra= atan2(y,x)
      endif
      
      return
      end

c-----------------------------------------------------------------------------
c This subroutine transforms ra & dec into x,y & z cartesian coordinates.
      subroutine radec_xyz(ra,dec,x,y,z)

      implicit none

      real x,y,z,ra,dec
      
      x=cos(dec)*cos(ra)
      y=cos(dec)*sin(ra)
      z=sin(dec)
      
      return
      end

c-----------------------------------------------------------------------------
c This subroutine transforms ra & dec into x,y & z cartesian coordinates.
      subroutine radecdble_xyz(ng,ra,dec,x,y,z)

      implicit none

      integer ng
      real x(*),y(*),z(*)
      real*8 ra(*),dec(*)
      
      integer i

      do i=1,ng
         x(i)=real(cos(dec(i))*cos(ra(i)))
         y(i)=real(cos(dec(i))*sin(ra(i)))
         z(i)=real(sin(dec(i)))
      enddo

      return
      end

c-----------------------------------------------------------------------------
      subroutine random_2df_sgp(dcos,costhemin,dphi,phimin)
c     Gives the general boundaries of the sgp region, in order not to compute 
c     too many randoms uselessly. Slightly conservative values...
c     Note however that theta and phi are between 0 & PI and 0 & 2PI.

      implicit none

      real dcos,costhemin,dphi,phimin

      real PI
      parameter (PI=3.1415926536)
      
      dcos=cos(110.*PI/180.)-cos(130.*PI/180.)
      costhemin=cos(130.*PI/180.)
      dphi=((360.-320.)+60.)*PI/180.
      phimin=-40.*PI/180.

      return
      end

c---------------------------------------------------------------------------
      subroutine random_2df_ngp(dcos,costhemin,dphi,phimin)
c     Gives the general boundaries of the ngp region, in order not to compute 
c     too many randoms uselessly. Slightly conservative values...
c     Note however that theta and phi are between 0 & PI and 0 & 2PI.

      implicit none

      real dcos,costhemin,dphi,phimin

      real PI
      parameter (PI=3.1415926536)
      
      dcos=cos(85.*PI/180.)-cos(100.*PI/180.)
      costhemin=cos(100.*PI/180.)
      dphi=(225.-140)*PI/180.
      phimin=140.*PI/180.

      return
      end

c----------------------------------------------------------------------------
      subroutine random_region(ramin,ramax,decmin,decmax
     &,                         dcos,costhemin,dphi,phimin)
c     Gives the general boundaries of a region, in order not to compute 
c     too many randoms uselessly.
c     Note however that theta and phi are between 0 & PI and 0 & 2PI.

      implicit none
      
      real ramin,ramax,decmin,decmax
      real dcos,costhemin,dphi,phimin
      real PI
      parameter (PI=3.1415926536)


      costhemin=cos(PI/2.-decmin)
      dcos=cos(PI/2.-decmax)-costhemin
      if (ramax.gt.ramin) then
         dphi=ramax-ramin
      else
         dphi=(2.*PI+ramax)-ramin
      endif
      phimin=ramin

      return
      end

c-----------------------------------------------------------------------------
      subroutine NP_set(NPX,NPY,NP,NPX_NPY)

c     This subroutine sets and checks that NP and NPX_NPY are correct and that
c     they correspond to the value used for NPX and NPY, the dimensions of the
c     pixel grid.
c     N.B.: NPX_NPY is also accepted if equal to 0 (default value if not 
c     used!)

      implicit none
      
      integer NPX,NPY,NP,NPX_NPY

      integer num

c     We define here NP as if we were using eq_apmsgppx(NP,...). We impose 
c     that NPX=3*NPY, in order to avoid distortions of the pixel grid (i.e.
c     the condition on NP is imposed in order to keep a square in the 2df_map
c     to be also a square in the apm_map!)

      NP=NPX*4/3 
      if (NP.ne.NPY*4) then
         write(0,*) 'Distortion of the pixel grid: NPX= ',NPX,' NPY='
     &,              NPY,' do not obey NPX=3*NPY!' 
         stop 'NP_set'
      endif

c     We check also that NPX_NPY is NPX*NPY or NPX_NPY = 0

      num=NPX*NPY
      if ((num.ne.NPX_NPY).and.(NPX_NPY.ne.0)) then
         write(0,*) 'Wrong dimension on NPX_NPY; should be ',num
         stop 'NP_set'
      endif

      return
      end

c-----------------------------------------------------------------------------
      subroutine boundary_2df(sgn,nb_strip,ra_min,ra_max,dec_min,dec_max)

c     This subroutine defines the general boundary of the 2dF survey.

      implicit none

      integer sgn,nb_strip
      real ra_min(3),ra_max(3),dec_min(3),dec_max(3)
 
      logical bound_2df


      bound_2df=.true. ! if true, uses the boundaries defined in 
                       ! Cole et al. 1998.
                       ! if false, uses specific boundaries.
 
      if (bound_2df) then
         if (sgn.eq.1) then
            nb_strip=3
            ra_min(1)= 5.707227    ! 21h48m
            ra_max(1)= 0.890118    !  3h24m
            dec_min(1)= -0.479966  ! -27.5 deg
            dec_max(1)= -0.392699  ! -22.5 deg
            ra_min(2)= 5.670138    ! 21h39.5m
            ra_max(2)= 0.975203    !  3h43.5m
            dec_min(2)= -0.567232  ! -32.5 deg
            dec_max(2)= -0.479966  ! -27.5 deg
            ra_min(3)= 5.711590    ! 21h49m
            ra_max(3)= 0.911935    !  3h29m
            dec_min(3)= -0.654498  ! -37.5 deg
            dec_max(3)= -0.567232  ! -32.5 deg
         else if (sgn.eq.-1) then
            nb_strip=1
            ra_min(1)= 2.574361    !  9h50m
            ra_max(1)= 3.883358    ! 14h50m
            dec_min(1)= -0.130900  !  -7.5 deg
            dec_max(1)= +0.043633  !  +2.5 deg
         endif
      else
         stop 'Boundaries not defined yet......boundary_2df'
         
      endif
     
      return
      end

c-----------------------------------------------------------------------------
      subroutine in_boundary_2df(sgn,ra,dec,in)

c     This subroutine tells whether a postion in ra and dec is inside (in=1)
c     or not (in=0) the 2dF boundary, specified in boundary_2df.

      implicit none

      integer sgn,in
      real ra,dec

      logical plate
      integer nb_strip,i,sgn1
      real ra_min(3),ra_max(3),dec_min(3),dec_max(3)
      save ra_min,ra_max,dec_min,dec_max,nb_strip,sgn1
      data sgn1/0/

      plate=.true. ! if true, the boundaries are defined by the 
                   ! APM plates used for the 2dF.
                   ! if false, the boundaries are defined by fixed
                   ! values in ra and dec decalred in boundary_2df.

      in=0
      if (plate) then
         call inside_plates(sgn,ra,dec,in)
      else
         if (sgn.ne.sgn1) then
            call boundary_2df(sgn,nb_strip,ra_min,ra_max,dec_min,dec_max)
            sgn1=sgn
         endif
         
         i=0
         if (sgn.eq.1) then
            do while (i.lt.nb_strip)
               i=i+1
               if (((ra_min(i).le.ra).or.(ra_max(i).ge.ra)).and.
     &              (dec_min(i).le.dec).and.(dec_max(i).ge.dec)) then
                  i=nb_strip+1
                  in=1
               endif
            enddo
         else
            do while (i.lt.nb_strip)
               i=i+1
               if ((ra_min(i).le.ra).and.(ra_max(i).ge.ra).and.
     &              (dec_min(i).le.dec).and.(dec_max(i).ge.dec)) then
                  i=nb_strip+1
                  in=1
               endif
            enddo
         endif
      endif

      return
      end
