c                                      #
c #####   ######    ##    #####       #   #    #  #####     #    #####  ######
c #    #  #        #  #   #    #     #    #    #  #    #    #      #    #
c #    #  #####   #    #  #    #    #     #    #  #    #    #      #    #####
c #####   #       ######  #    #   #      # ## #  #####     #      #    #
c #   #   #       #    #  #    #  #       ##  ##  #   #     #      #    #
c #    #  ######  #    #  #####  #        #    #  #    #    #      #    ######
c
c
c   ##     ####    ####      #       #
c  #  #   #       #    #     #       #
c #    #   ####   #          #       #
c ######       #  #          #       #
c #    #  #    #  #    #     #       #
c #    #   ####    ####      #       #
c
c---------------------------------------------------------------------------
      subroutine readascii_col(name,icol,n,x)

      implicit none

      integer icol,n
      real x(*)
      character name*(*)

      logical comments,header
      integer ncolmax
      parameter (ncolmax=50)
      integer i,j,istat,nb_col
      real valcol(ncolmax)
      character string*400


      open(10,file=name,status='unknown',form='formatted')

c     Find the start of data in the file: uses unit 10
      call findstart(string,comments,header)

c     Find the number of columns and check that it is possible to read icol
      call asciicol(header,string,nb_col,icol,ncolmax)

      istat=0
      j=0
      do while (istat.eq.0)
         read(10,*,iostat=istat) (valcol(i),i=1,icol)
         if (istat.eq.0) then
            j=j+1
            x(j)=valcol(icol)
         endif
      enddo
      close(10)
      n=j
c      write(*,*) 'number of lines read:',n

      return
      end

c---------------------------------------------------------------------------
      subroutine readascii_coli(name,icol,n,x)

      implicit none

      integer icol,n,x(*)
      character name*(*)

      logical comments,header
      integer ncolmax
      parameter (ncolmax=50)
      integer i,j,istat,nb_col,valcol(ncolmax)
      character string*400


      open(10,file=name,status='unknown',form='formatted')

c     Find the start of data in the file: uses unit 10
      call findstart(string,comments,header)

c     Find the number of columns and check that it is possible to read icol
      call asciicol(header,string,nb_col,icol,ncolmax)

      istat=0
      j=0
      do while (istat.eq.0)
         read(10,*,iostat=istat) (valcol(i),i=1,icol)
         if (istat.eq.0) then
            j=j+1
            x(j)=valcol(icol)
         endif
      enddo
      close(10)
      n=j
c      write(*,*) 'number of lines read:',n

      return
      end

c--------------------------------------------------------------------------
c     This program appends a column to an ascii file: extremly slow 
c     processus however!
      subroutine writeascii_col(name,title,n,x)

      implicit none

      integer n
      real x(*)
      character name*(*),title*(*)

      logical comments
      integer istat,lnblnk,i
      character string*400,string1*400,namecopy*100,title1*12



      namecopy='temp.txt'
      comments=.false.

      istat=0
      open(10,file=name,status='unknown',form='formatted')
      read(10,'(a)',iostat=istat) string
      if (istat.eq.0) then
         write(0,*) 'File: ',name(1:lnblnk(name)),' contain data!'
         if (index(string,'#').eq.1) then
            write(0,*) 'Header: ', string(1:lnblnk(string))
            read(10,'(a)') string1
d            write(0,*) 'Next line: ', string1(1:lnblnk(string1))
            if (index(string1,'#').eq.1) comments=.true.
         else
            write(*,*) 'Ascii file do not have any header!'
            stop 'writeascii_col: cannot process such files!'
         endif
      else !File is empty. Trivial to add information to it then...
         write(*,*) 'File: ',name(1:lnblnk(name)),' is empty!'
         rewind 10

c        Set the right length to the title
         call appendtitle(title,title1)

         write(10,'(a2,a12,a1)') '# ',title1,'|'
         do i=1,n
            write(10,100) x(i)
         enddo
         close(10)
         return
      endif

c     Loop over all comment lines and copy them over to unit 11....
d      write(0,*) 'Comments: ',comments,' file copy: ',namecopy
      open(11,file=namecopy,status='unknown',form='formatted')
      if (comments) write(11,'(a)') string(1:lnblnk(string))
      do while (comments)
         string=string1
         read(10,'(a)') string1
d         write(0,*) 'string1: ',string1
         if (index(string1,'#').le.0.05) then ! string1 read 1st line of data
            comments=.false.
         else
            write(11,'(a,1x,i8)') string(1:lnblnk(string))
         endif
      enddo

c     Append the title of last column to the column header
      call appendtitle(title,title1)

      write(11,'(a,a1,a,a1)') string(1:lnblnk(string)-1),' ',title1,'|'
      
      i=1
      write(11,110) string1(1:lnblnk(string1)),' ',x(i)

      istat=0
      do while (istat.eq.0)
         read(10,'(a)',iostat=istat) string1
         if (istat.eq.0) then
            i=i+1
            write(11,110) string1(1:lnblnk(string1)),' ',x(i)
         endif
      enddo
      close(11)
      close(10)

      if (i.ne.n) stop 'writeascii_col: too much data for this file!'
     
      call rightfile(name,namecopy,string)

 100  format(2x,f12.6)   ! length of title1 should be the same as the
 110  format(a,a1,f12.6) ! length of the full column
      
      return
      end

c--------------------------------------------------------------------------
c     This program appends a column to an ascii file: extremly slow 
c     processus however!
      subroutine writeascii_coli(name,title,n,x)

      implicit none

      integer n,x(*)
      character name*(*),title*(*)

      logical comments
      integer istat,lnblnk,i
      character string*400,string1*400,namecopy*100,title1*12



      namecopy='temp.txt'
      comments=.false.

      istat=0
      open(10,file=name,status='unknown',form='formatted')
      read(10,'(a)',iostat=istat) string
      if (istat.eq.0) then
         write(*,*) 'File: ',name(1:lnblnk(name)),' contain data!'
         if (index(string,'#').eq.1) then
            write(*,*) 'Header: ', string(1:lnblnk(string))
            read(10,'(a)') string1
c            write(*,*) 'string1: ', string1
            if (index(string1,'#').eq.1) comments=.true.
         else
            write(*,*) 'Ascii file do not have any header!'
            stop 'writeascii_col: cannot process such files!'
         endif
      else !File is empty. Trivial to add information to it then...
         write(*,*) 'File: ',name(1:lnblnk(name)),' is empty!'
         rewind 10
c        Set the right length to the title
         call appendtitle(title,title1)

         write(10,'(a2,a,a1)') '# ',title1,'|'
         do i=1,n
            write(10,100) x(i)
         enddo
         close(10)
         return
      endif

c     Loop over all comment lines and copy them over to unit 11....
      open(11,file=namecopy,status='unknown',form='formatted')
      if (comments) write(11,'(a)') string(1:lnblnk(string))
      do while (comments)
         string=string1
         read(10,'(a)') string1
         if (index(string1,'#').ne.0) then ! string1 read the 1st line of data
            comments=.false.
         else
            write(11,'(a)') string(1:lnblnk(string))
         endif
      enddo

c     Append the title of last column to the column header
      call appendtitle(title,title1)

      write(11,'(a,a1,a,a1)') string(1:lnblnk(string)-1),' ',title1,'|'
      
      i=1
      write(11,110) string1(1:lnblnk(string1)),' ',x(i)

      istat=0
      do while (istat.eq.0)
         read(10,'(a)',iostat=istat) string1
         if (istat.eq.0) then
            i=i+1
            write(11,110) string1(1:lnblnk(string1)),' ',x(i)
         endif
      enddo
      close(11)
      close(10)

      if (i.ne.n) stop 'writeascii_col: too much data for this file!'
     
      call rightfile(name,namecopy,string)

 100  format(2x,I12)   ! length of title1 should be the same as the
 110  format(a,a1,I12) ! length of the full column
      
      return
      end

c--------------------------------------------------------------------------
      subroutine findstart(string,comments,header)

      implicit none

      logical comments,header
      character string*(*)

      integer lnblnk
      character stringhelp*400


      read(10,'(a)') string
      if (index(string,'#').eq.1) then
         comments=.true.
         header=.true.
      else
         write(*,*) 'Ascii file do not have any header!'
         header=.false.
c         write(*,*) 'string: ', string(1:lnblnk(string)),'!'
         !stop 'readascii_col: cannot process such files!'
         stringhelp(3:lnblnk(string)+2)=string
         stringhelp(1:2)='# '
         stringhelp(lnblnk(string)+3:lnblnk(string)+3)=' '
         string=stringhelp
         backspace 10
         return
      endif

c     Loop over all comment lines
      do while (comments)
         read(10,'(a)') string
         if (index(string,'#').eq.0) comments=.false.
      enddo
      backspace 10 
      backspace 10
      read(10,'(a)') string ! reread the line with the columns definitions
c      write(*,*) 'Header: ',string(1:lnblnk(string))

      return
      end

c--------------------------------------------------------------------------
      subroutine asciicol(header,string,nb_col,icol,ncolmax)

      implicit none

      logical header
      integer nb_col,icol,ncolmax
      character string*(*)
      
      integer len,i,lnblnk

c     Finding the number of columns in the file:
c       - those with header: -1 to take away '|' which shows 
c         where the end of the header is!
c       - those without header
c
      if (header) then
         len=lnblnk(string)-1
      else
         len=lnblnk(string)
      endif
      i=index(string,'#')+1
      nb_col=0
      do while (i.lt.len)
         do while ((string(i:i).eq.' ').and.(i.lt.len))
            i=i+1
         enddo
         if (i.lt.len) nb_col=nb_col+1   ! count the number of columns
         do while ((string(i:i).ne.' ').and.(i.lt.len))
            i=i+1
         enddo
      enddo
c      write(*,*) 'nb_col:', nb_col,len

c     Checks that the information can be read
      if (icol.gt.ncolmax) then
         write(*,*) 'Too many columns to be read:',icol,ncolmax
         stop 'readascii_col: information not read!'
      endif

      if (icol.gt.nb_col) then
         write(*,*) 'Not enough columns in this file:',nb_col,icol
         stop 'readascii_col: information not read!'
      endif
      
      return
      end

c----------------------------------------------------------------------------
      subroutine appendtitle(title,title1)

      implicit none

      character title*(*),title1*(*)

      integer lnblnk,i,j

      if (lnblnk(title).le.len(title1)) then
         i=(len(title1)-lnblnk(title))/2 !centering of title...
         do j=1,i
            title1(j:j)=' '
         enddo
         title1(i+1:i+1+lnblnk(title))=title(1:lnblnk(title))
         do j=i+2+lnblnk(title),len(title1)
            title1(j:j)=' '
         enddo
      else 
         write(*,*) 'Title length will be shortened!'
         title1=' '//title(1:len(title1)-1)
      endif

      return
      end

c---------------------------------------------------------------------------
      subroutine rightfile(name,name1,string)

      implicit none

      character name*(*),name1*(*),string*(*)

      integer istat,lnblnk

      open(10,file=name,status='unknown',form='formatted')
      open(11,file=name1,status='unknown',form='formatted')
      
      istat=0
      do while (istat.eq.0)
         read(11,'(a)',iostat=istat) string
         if (istat.eq.0) write(10,'(a)') string(1:lnblnk(string))
      enddo

      close(10)
      close(11)

      return
      end
